"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useChangeEffect = void 0;
const react_1 = require("react");
const useUpdateEffect = (effect, deps) => {
    const firstMount = (0, react_1.useRef)(true);
    (0, react_1.useEffect)(() => {
        if (firstMount.current) {
            firstMount.current = false;
            return;
        }
        effect();
    }, deps);
};
const usePrevious = (deps) => {
    const prevRef = (0, react_1.useRef)(deps);
    (0, react_1.useEffect)(() => {
        prevRef.current = deps;
    }, deps);
    return prevRef.current;
};
const useChangeEffect = (effect, deps) => {
    const prevValue = usePrevious(deps);
    useUpdateEffect(() => {
        effect(...prevValue);
    }, deps);
};
exports.useChangeEffect = useChangeEffect;
